<%@page pageEncoding="UTF-8" contentType="text/html;charset=UTF-8"%>
<%@page import="java.util.*"%>
<%@page import="org.apache.commons.fileupload.*" %>
<%@page import="org.apache.commons.fileupload.servlet.ServletFileUpload"%>
<%@page import="org.apache.commons.fileupload.disk.DiskFileItemFactory"%>
<%@page import="java.io.*"%>
<%@page import="org.apache.commons.io.IOUtils"%>
<%@page import="java.net.URL"%>
<html>
	<head>
		<meta http-equiv="content-type" content="text/html;charset=UTF-8"/>
		<script type="text/javascript" src="gears_init.js"></script>
		<script type="text/javascript">
			
			var STORE_NAME = "FILE_SUBMITTER_EXAMPLE";
			var FILE_URL_PREFIX = "files/";
			var localServer = null;
			var resourceStore = null;
			var uploadFileUrls = [];

			// ページ読み込みが完了した際呼び出される関数
			function init() {
				localServer = google.gears.factory.create("beta.localserver", "1.0");
				resourceStore = localServer.createStore(STORE_NAME);
			}
			function captureLocalFile() {
				
				var tmpUrl = FILE_URL_PREFIX + "tmp_" + new Date().getTime();
				
				var fileElement = document.getElementById("uploadFile");
				
				resourceStore.captureFile(fileElement, tmpUrl);
				var capturedFileName = resourceStore.getCapturedFileName(tmpUrl);

				var fileUrl = FILE_URL_PREFIX + capturedFileName;
				resourceStore.rename(tmpUrl, fileUrl);

				uploadFileUrls.push(fileUrl);
				
				showMessage(capturedFileName + "の取り込みが完了しました。")
				
				var link = "<a href='" + fileUrl + "'>" + capturedFileName + "</a>"
				document.getElementById("uploadFiles").innerHTML += "<li>" + link + "</li>";
			}
			// 取り込まれたファイルのアップロードを行います。
			function uploadFiles() {
				// リソースストアに格納されたファイルを送信するための
				// FileSubmitterを生成
				var fileSubmitter = resourceStore.createFileSubmitter();
				
				var form = document.forms[0];
				for (var i = 0; i < uploadFileUrls.length; i++) {
					// ファイルデータを紐付けるための要素を生成
					var fileInputElement = createFileInputElement("uploadFile_" + i);
					// フォーム内に追加
					form.appendChild(fileInputElement);
					// リソースストアのURLを要素に関連付け
					fileSubmitter.setFileInputElement(fileInputElement, uploadFileUrls[i]);
				}
				// このファイル選択フィールドは送信データに含めないよう、利用不可にしておく
				document.getElementById("uploadFile").disabled = true;
				// フォームの送信
				form.submit();
			}
			// アップロードするファイルデータを紐付けるための要素を生成します。
			function createFileInputElement(elementName) {
				// ファイルデータを紐付ける要素の種類はブラウザによって変える必要がある
				// Internet Explorerの場合、<input>以外の要素 (ここではtextareaを使用)
				// Firefoxの場合は、<input type="file">でなくてはならない
				var fileInputElement;
				if(navigator.appName == 'Microsoft Internet Explorer'){
					fileInputElement = document.createElement("a");
				} else {
					fileInputElement = document.createElement("input");
					fileInputElement.setAttribute("type", "file");
				}
				// name属性は、リクエストパラメータの名前となる
				fileInputElement.name = elementName;
				// 要素を不可視に
				fileInputElement.style.visibility = "hidden";
				
				return fileInputElement;
			}
			function showMessage(message) {
				document.getElementById("message").innerHTML = message;
			}
			
		</script>
	</head>
	<body onload="init()">
		<h1>ファイルアップロードのサンプル</h1>
		<%
			// リクエストのコンテントタイプに"multipart/form-data"が入っている時のみ処理を行う
			String contentType = request.getContentType();
			if (contentType != null &&
				contentType.contains(ServletFileUpload.MULTIPART_FORM_DATA)) {
				
				// Commons FileUploadのAPIを使用してアップロードされたファイルを処理
				DiskFileItemFactory factory = new DiskFileItemFactory();
				ServletFileUpload upload = new ServletFileUpload(factory);
				
				for (FileItem fileItem : (List<FileItem>) upload.parseRequest(request)) {
					if (fileItem.isFormField()) {
						continue;
					}
					// コンテキストパス/files/ファイル名となるようにコピー
					String fileName = new File(fileItem.getName()).getName();
					String filePath = application.getRealPath("/files/" + fileName);
					IOUtils.copy(
						fileItem.getInputStream(),
						new BufferedOutputStream(new FileOutputStream(filePath)));
					out.print("<strong>" + fileName + "</strong>がアップロードされました。<br/>");
				}
			}
		%>
		<form method="post" enctype="multipart/form-data">
			<input type="file" id="uploadFile" name="uploadFile" onchange="captureLocalFile()"/>
			<input type="button" value="アップロード" onclick="uploadFiles()"/>
		</form>
		<div id="message"></div>
		<ul id="uploadFiles">
		</ul>
	</body>
</html>
