var GEARS_LOCALSERVER	= "beta.localserver";
var GEARS_DATABASE		= "beta.database";
var GEARS_WORKERPOOL	= "beta.workerpool";
var GEARS_HTTPREQUEST	= "beta.httprequest";
var GEARS_TIMER			= "beta.timer";
var GEARS_LOCALSERVER_VERSION	= "1.0";
var GEARS_DATABASE_VERSION		= "1.0";
var GEARS_WORKERPOOL_VERSION	= "1.0";
var GEARS_HTTPREQUEST_VERSION	= "1.0";
var GEARS_TIMER_VERSION			= "1.0"

var DB_NAME = "SimpleOfflineAppDB";
var STORE_NAME = "SimpleOfflineAppStore";
var MANIFEST = "manifest.json";

var GLOBAL = {};

function initGlobalVars() {
	GLOBAL.hasGears = (google && google.gears) != undefined;
	if (GLOBAL.hasGears) {
		try {
			// 必要な全てのGearsオブジェクトを一旦初期化し、適切なバージョンのGearsが利用可能かどうか調べる。
			GLOBAL.db = google.gears.factory.create(GEARS_DATABASE, GEARS_DATABASE_VERSION);
			GLOBAL.db.open(DB_NAME);
			GLOBAL.localServer = google.gears.factory.create(GEARS_LOCALSERVER, GEARS_LOCALSERVER_VERSION);
			GLOBAL.managedStore = GLOBAL.localServer.createManagedStore(STORE_NAME);
			var tmpWorkerPool = google.gears.factory.create(GEARS_WORKERPOOL, GEARS_WORKERPOOL_VERSION);
			var tmpTimer = google.gears.factory.create(GEARS_TIMER, GEARS_TIMER_VERSION);
			var tmpRequest = google.gears.factory.create(GEARS_HTTPREQUEST, GEARS_HTTPREQUEST_VERSION);
			
			GLOBAL.onlineOnly = false;
		} catch (e) {
			// Gearsの利用ができない場合はオンライン利用のみ可
			GLOBAL.onlineOnly = true;
		}
	}
}
