var LocalStore = {};
// データの読み出し
LocalStore.load = function() {
	var rs = null;
	try {
		rs = GLOBAL.db.execute("select * from DATA");
		if (rs.isValidRow()) {
			return {
				content: rs.fieldByName("CONTENT"),
				version: rs.fieldByName("VERSION")
			};
		} else {
			return null;
		}
	} finally {
		if (rs) rs.close();
	}
};
// データの保存
LocalStore.save = function(data) {
	GLOBAL.db.execute("begin");
	try {
		// データが存在する場合はupdate、ない場合はinsert
		if (LocalStore.load() != null) {
			GLOBAL.db.execute(
				"update DATA set CONTENT = ?, VERSION = ?",
				[data.content, data.version]);
		} else {
			GLOBAL.db.execute(
				"insert into DATA (CONTENT, VERSION) values (?, ?)",
				[data.content, data.version]);
		}
		GLOBAL.db.execute("commit");
	} catch (e) {
		GLOBAL.db.execute("rollback");
		throw e;
	}
};
