var Store = {};

Store.onUpload = {};
Store.onDownload = {};

// アプリケーション初期化時に行う同期処理
Store.init = function() {
	// オンライン利用のみの場合はサーバからロードするのみ
	// オフライン可の場合は、サーバ上のデータと同期する
	if (GLOBAL.onlineOnly) {
		RemoteStore.load(this.onDownload);
	} else {
		this.sync();
	}
};


// 保存ボタンをクリックされた際の処理
Store.save = function(data) {
	// オンライン利用のみの場合はサーバに保存するのみ
	// オフライン可の場合は、ローカルデータベースに保存した後、サーバ上のデータと同期する
	if (GLOBAL.onlineOnly) {
		RemoteStore.save(data, this.onUpload);
	} else {
		LocalStore.save(data);
		this.sync();
	}
};
// 実際の同期処理
Store.sync = function() {
	// ローカルデータベースからデータを取り出し、
	// サーバに保存する
	var localData = LocalStore.load();
	RemoteStore.save(localData, {
		// サーバへの保存が成功したら
		success: function(data) {
			Store.onUpload.success(data);
			// 次はサーバからデータを読み出し、ローカルに保存する
			RemoteStore.load({
				success: function(data) {
					LocalStore.save(data);
					Store.onDownload.success(data);
				},
				error: Store.onDownload.error
			});
		},
		conflict: Store.onUpload.conflict,
		error: Store.onUpload.error,
		networkError: function(status, statusText) {
			// サーバに接続できない時は、ローカルデータで代用
			Store.onDownload.success(localData);
		}
	});
};
