var Store = {};

Store.onUpload = {};
Store.onDownload = {};

// アプリケーション初期化時に行う同期処理
Store.init = function() {
	// オンライン利用のみの場合はサーバからロードするのみ
	// オフライン可の場合は、サーバ上のデータと同期する
	if (GLOBAL.onlineOnly) {
		RemoteStore.load(this.onDownload);
	} else {
		var localData = LocalStore.load();
		this.onDownload.success(localData);
	}
};

// 保存ボタンをクリックされた際の処理
Store.save = function(data) {
	// オンライン利用のみの場合はサーバに保存するのみ
	// オフライン可の場合は、ローカルデータベースに保存した後、サーバ上のデータと同期する
	if (GLOBAL.onlineOnly) {
		RemoteStore.save(data, this.onUpload);
	} else {
		// アクションログの追加
		var action = {name: "save", data: data};
		dojox.off.sync.actions.add(action);
		// ローカルDBに保存
		LocalStore.save(data);
		this.onUpload.success(data);
	}
};

// ユーザ操作のリプレイ
dojo.connect(dojox.off.sync.actions, "onReplay", this,
	function(action, actionLog) {
		if (action.name == "save") {
			var localData = action.data;
			RemoteStore.save(localData, {
				// サーバへの保存が成功
				success: function(data) {
					Store.onUpload.success(data);
					actionLog.continueReplay();
				},
				// 衝突が発生した場合
				conflict: function(remoteData, localData) {
					Store.onUpload.conflict(remoteData, localData);
					actionLog.continueReplay();
				},
				error: function(result) {
					actionLog.haltReplay();
					Store.onUpload.error(result);
				},
				networkError: function(status, statusText) {
					actionLog.haltReplay();
					Store.onUpload.networkError(status, statusText);
				}
			});
		}
	});

// 同期イベントを処理
dojo.connect(dojox.off.sync, "onSync", null, onSync);
function onSync(type) {
	switch (type) {
		// ダウンロード時
		case "download":
			RemoteStore.load({
				success: function(data) {
					LocalStore.save(data);
					Store.onDownload.success(data);
					dojox.off.sync.finishedDownloading();
				},
				error: function(status, statusText) {
					Store.onDownload.error(status, statusText);
					dojox.off.sync.finishedDownloading(
						false, "エラー" + statusText);
				}
			});
			break;
	}
}