package gears.book.chap3;
import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * データの読み出しを行うサーブレットです
 * @author Shumpei Shiraishi
 *
 */
@SuppressWarnings("serial")
public class LoadAPIServlet extends HttpServlet {
	
	private static final DataStore dataStore = DataStore.getInstance();
	
	@Override
	protected void doGet(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		// データを読み出して、JSON形式にして返す
		Data currentData = dataStore.loadData();
		req.setAttribute("data", currentData);
		req.getRequestDispatcher("/WEB-INF/jsp/data.json.jsp").forward(req, resp);
	}
}
