package gears.book.chap3;
import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


@SuppressWarnings("serial")
public class SaveAPIServlet extends HttpServlet {
	private DataStore dataStore = DataStore.getInstance();
	
	@Override
	protected void doPost(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		String content = req.getParameter("content");

		// クライアントから文字列が送信されていた場合のみ保存処理を行う
		if (content != null) {
			long version = Long.parseLong(req.getParameter("version"));
			
			Data clientData = new Data();
			clientData.setContent(content);
			clientData.setVersion(version);
			
			synchronized (dataStore) {
				try {
					dataStore.saveData(clientData);
				} catch (ConflictException e) {
					// コンフリクトが発生した場合
					req.setAttribute("serverData", dataStore.loadData());
					req.setAttribute("clientData", clientData);
					req.getRequestDispatcher("/WEB-INF/jsp/conflictError.json.jsp").forward(req, resp);
					return;
				}
			}
		}
		// 最新のデータをクライアントに返す
		req.setAttribute("data", dataStore.loadData());
		req.getRequestDispatcher("/WEB-INF/jsp/data.json.jsp").forward(req, resp);
	}
}
