package client;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.gears.core.client.GearsException;
import com.google.gwt.gears.workerpool.client.MessageHandler;
import com.google.gwt.gears.workerpool.client.WorkerPool;
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.RootPanel;
import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.Widget;

public class GWTWorkerPoolExample implements EntryPoint {
	private TextBox num = new TextBox();
	private Button performButton = new Button("処理開始");
	// ワーカプール
	private WorkerPool workerPool;
	// ワーカのスクリプト (第二章のものと同じ)
	private static final String WORKER_SCRIPT =
		"function childHandler(message, sender) {" +
		  "var n = parseInt(message, 10);" +
		  "var result = sum(n);" +
		  "google.gears.workerPool.sendMessage(String(result), sender);" +
		"}" +
		"function sum(n) {" +
		  "var result = 0;" +
		  "for (var i = 0; i < n; i++) {" +
		    "result += i;" +
		  "}" +
		  "return result;" +
		"}" +
		"google.gears.workerPool.onmessage = childHandler";
	
	public void onModuleLoad() {
		try {
			// ワーカプールの生成 (引数はメッセージハンドラ)
			workerPool = new WorkerPool(new MessageHandler() {
				public void onMessageReceived(String message, int srcWorker) {
					// 子ワーカからメッセージを受け取ると、それをアラートで表示する
					Window.alert(message);
				}
			});
		} catch (GearsException e) {
			Window.alert("エラーが発生しました:" + e.getMessage());
			return;
		}
		// 「処理開始ボタン」のクリックイベントを捕捉するリスナを追加
		performButton.addClickListener(new ClickListener() {
			public void onClick(Widget sender) {
				String n = num.getText();
				try {
					// ワーカを生成し、メッセージ (ユーザの入力値) を送信
					int workerId = workerPool.createWorkerFromString(WORKER_SCRIPT);
					workerPool.sendMessage(n, workerId);
				} catch (GearsException e) {
					Window.alert("エラーが発生しました:" + e.getMessage());
				}
			}
		});
		// 画面に対し、ウィジェットの貼り付け
		RootPanel.get("num").add(num);
		RootPanel.get("performButton").add(performButton);
	}
}
